/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.TipoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoVenta;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaTipoVentaController")
@Scope("prototype")
public class BusquedaTipoVentaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<TipoVenta> plwTipoVenta;
	private MyListbox tipoVentaList;
	private Paging pagingTipoVenta;
	private Textbox txtNombre;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		tipoVentaList.setItemRenderer(new RenderTipoVenta());
		tipoVentaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				TipoVenta ts = (TipoVenta) tipoVentaList.getSelected();
				verPeriodo(ts);
			}
		});

		refreshLista();

		txtNombre.focus();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verPeriodo(TipoVenta ts) {
		if (ts == null) {
			return;
		}

		Map args = new HashMap();
		args.put("tipoVenta", ts);
		args.put("tipoVentaList", tipoVentaList);

		openWindow("/gui/catalogos/editarTipoVenta.zul",
				Labels.getLabel("editarTipoVentaController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<TipoVenta> claseVentaBusqueda =
				new HibernateSearchObject<TipoVenta>(TipoVenta.class, pagingTipoVenta.getPageSize());

		claseVentaBusqueda.addFilterLike("desctipoventa", "%" + txtNombre.getText().trim().concat("%"));
		claseVentaBusqueda.addFilterEqual("activo", Boolean.TRUE);
		claseVentaBusqueda.addSortAsc("desctipoventa");
		claseVentaBusqueda.addFilterNotEqual("tipoventaId", -1);

		plwTipoVenta.init(claseVentaBusqueda, tipoVentaList, pagingTipoVenta);

		if (tipoVentaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaTipoVentaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPeriodo(new TipoVenta());
	}
}
